#include <signal.h>
#include <time.h>
#include <sys/types.h>
#include <bits/siginfo.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <asm/unistd.h>
#include <linux/baio.h>
#include <sched.h>

_syscall3(int, open_dseg, char*, dev,  char*, dname, int, mode)
_syscall1(int, close_dseg, int, blockfd)
_syscall1(int, baio, baio_desc *, desc)
_syscall0(int, baio_service);
_syscall1(int, set_baio_slave, int, pid)
_syscall4(int, create_dseg, char*, devname, char*, dname, int, nr_blocks, int *, actual_nr)
	

int create_baio_serv_thread(void *a)
{
	baio_service();
	exit(1);
}


int init_baio()
{
	char * cstack = (char *) malloc(256 * 1024);
	int pid;
	cstack += (32 * 1024);
	cstack = (char *)((unsigned long)cstack & 0xfffff000);

	pid = clone(create_baio_serv_thread, cstack, SIGCHLD|CLONE_VM|CLONE_FS|CLONE_FILES, 0);
	if (pid < 0) {
		perror("clone");
		exit(-1);
	}
	if (pid != 0)
		set_baio_slave(pid);
}
	

